mod Maux logic: 'cl'

incl Mtex

rem 
  \para \bf  Finite Sequences.  \end 

fun L 
  L(0) = 0
  L(v,w) = L(w)+1

lemma L_is_zero
  L(x) = 0 <-> x = 0
proof 
 case Ln; x @ 0; v,w
  proved
  proved..

fun/2 Sub 'Tex_f2_ln_sub'
  Sub((v,w),0) = v
  Sub((v,w),i+1) = Sub(w,i)

thm Eq_seq
  x = y <-> L(x) = L(y) & \a i(i < L(x) -> Sub(x,i) = Sub(y,i))
proof 
 ind Ln; x; y @ 0; v1,w1
  use L_is_zero.0; y proved.
  case Ln; y @ 0; v2,w2
   proved
   weak y = v2,w2
    inst \a y(w1 = y <-> L(w1) = L(y) & \a i(i < L(w1) -> Sub(w1,i) = Sub(y,i))).0; w2
     weak \a y(w1 = y <-> L(w1) = L(y) & \a i(i < L(w1) -> Sub(w1,i) = Sub(y,i)))
      weak w1 = w2 <-> L(w1) = L(w2) & \a i(i < L(w1) -> Sub(w1,i) = Sub(w2,i))
       cut L(w2) = L(w1)
        weak L(w2) = L(w1)
         split* v1 = v2 & \a i(i < L(w1) -> Sub(w1,i) = Sub(w2,i)) <-> 
                \a i(i <= L(w1) -> Sub((v1,w1),i) = Sub((v2,w2),i)).2,0,1,0,4,0,
                                                                    0,0
          weak v1 = v2
           eigen* \a i(i <= L(w1) -> Sub((v2,w1),i) = Sub((v2,w2),i)).0; i
            case N; i @ 0; j
             proved
             inst \a i(i < L(w1) -> Sub(w1,i) = Sub(w2,i)); j proved....
          inst \a i(i <= L(w1) -> Sub((v1,w1),i) = Sub((v2,w2),i)); 0 proved.
          eigen* \a i(i < L(w1) -> Sub(w1,i) = Sub(w2,i)).0; i
           inst \a i(i <= L(w1) -> Sub((v1,w1),i) = Sub((v2,w2),i)); i+1 proved....
        proved........

