mod Ul05 logic: 'cl'

incl Mtex

incl Maux

loc rem 
  \para \bf  PREMIOVA ULOHA Z PREDMETU 1-AIN-470 SPECIFIKACIA A VERIFIKACIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end streda 23.4.2008 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-470-svp/0708ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subory \it  mtex*.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subory \it  maux*.cl  \end obsahuju definicie a vlastnosti 
         pomocnych funkcii a predikatov. 
   \item \para Subor \it  ul*.cl  \end obsahuje priklady, ktore mate vyriesit v 
         tejto premiovej ulohe. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Pocet bodov za ulohu: \bf  \it  8  \end  \end. 
   \item \para Hodnoti sa len kompletne vyriesena uloha. 
   \item \para Ulohy rieste \bf  \it  samostatne!  \end  \end 
  \end
  \para Ulohu treba odovzdat do 5.5.2008 (pondelok) do 14:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  [CL] CL-TeX.  \end 

appldisp/3 Tex_p3_gr
  Prefix(100,2,Id(0,Ent('phi'),0),
         Fenced(Op('[',0),
                Infix(Arg(0),30,2,Op(',',0),Infix(Arg(1),30,2,Op(',',0),Arg(2))),
                Op(']',0)))

theory Primitive_recursion

fun G 'Tex_f1_g'

fun/3 H1 'Tex_f3_h'

rem 
  \para \bf  Introduction.  \end Our goal is to formalize primitive recursion 
  \def 
    fun/2 F 'Tex_f2_f'
    F(0,y) = G(y)
    F(x+1,y) = H1(x,y,F(x,y))
  \end
  \para within Peano arithmetic. 

rem 
  \para \bf  Course of values sequences.  \end 

pred/3 Cvs 
  Cvs(s,x,y) <-> L(s) = x+1 & Sub(s,x) = G(y) & 
                 \a u(u < x -> Sub(s,x-(u+1)) = H1(u,y,Sub(s,x-u)))

rem 
  \para \bf  The graph.  \end 

pred/3 Gr 'Tex_p3_gr'
  Gr(x,y,z) <-> \e s(Cvs(s,x,y) & Sub(s,0) = z)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    \e zGr(x,y,z)
  \end
  \eq* 
    Gr(x,y,z1) & Gr(x,y,z2) -> z1 = z2
  \end

thm Gre
  \e zGr(x,y,z)

thm Gru
  Gr(x,y,z1) & Gr(x,y,z2) -> z1 = z2

rem 
  \para \bf  Contextual definition.  \end 

fun/2 F 'Tex_f2_f'

axiom Fdef
  F(x,y) = z <-> Gr(x,y,z)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    F(0,y) = G(y)
  \end
  \eq* 
    F(x+1,y) = H1(x,y,F(x,y))
  \end

thm F0
  F(0,y) = G(y)

thm F1
  F(x+1,y) = H1(x,y,F(x,y))

end theory Primitive_recursion

